#include "common/utils.hpp"
#include "nodes/base/base.hpp"
#include "nodes/httpPush/httpPush.hpp"

namespace Node
{

void HttpPushNode::work()
{
    printf("HttpPush %s\n", name_.c_str());
    while (running_)
    {
        bool has_data = false;
        for (auto& input_buffer : input_buffers_)
        {
            std::shared_ptr<meta::MetaData> metaData;
            if (!input_buffer.second->try_pop(metaData))
            {
                continue;
            }
            has_data = true;
            // printf("Node %s get data from %s\n", name_.c_str(), input_buffer.first.c_str());
            // do something
            cv::Mat image = metaData->draw_image;
            std::string image_name = "result/" + metaData->from + "_" + getTimeString() + ".jpg";
            cv::imwrite(image_name, image);
        }
        if (!has_data) {
            std::unique_lock<std::mutex> lock(mutex_);
            cond_var_->wait_for(lock, std::chrono::milliseconds(100), [this] {
                return !running_;  // 等待时检查退出条件
            });
        }
    }
};

}   // namespace Node